import { login, logout, getInfo,changeLoginUser } from '@/api/login'
import { getToken, setToken, removeToken } from '@/utils/auth'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    roles: [],
    permissions: [],
    dept:{},
    orgType:'',
    orgId: '',
    userType:'',
    userGuid:'',
    sideline: ''
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    },
    SET_DEPT:(state,dept) =>{
      state.dept = dept
    },
    SET_ORG_TYPE:(state,orgType) =>{
      state.orgType = orgType
    },
    SET_ORG_ID:(state,orgId) =>{
      state.orgId = orgId
    },
    SET_USER_GUID:(state,userGuid) =>{
      state.userGuid = userGuid
    },
    SET_SIDELINE:(state,sideline) =>{
      state.sideline = sideline
    },
    SET_USER_TYPE:(state,userType) =>{
      if(userType.startsWith(",")){
        userType = userType.substring(1); 
      }
      if(userType.endsWith(",")){
        userType = userType.substring(0, userType.length-1); 
      }
      state.userType = userType + ",0";// 每个人默认都有属于经办人
    }
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid;
      const token = userInfo.token;
      const loginType = userInfo.loginType;
      return new Promise((resolve, reject) => {
        login(username, password, code, uuid, token, loginType).then(res => {
          setToken(res.token)
          commit('SET_TOKEN', res.token)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.user
          const avatar = (user.avatar == "" || user.avatar == null) ? require("@/assets/images/profile.jpg") : process.env.VUE_APP_BASE_API + user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          commit('SET_PERMISSIONS', res.permissions)
          commit('SET_ID', user.userId)
          commit('SET_NAME', user.userName)
          commit('SET_AVATAR', avatar)
          commit('SET_DEPT',res.dept)
          commit('SET_ORG_TYPE',res.orgType)
          commit('SET_ORG_ID',res.orgId)
          commit('SET_USER_GUID',user.userGuid)
          commit('SET_USER_TYPE',user.userType)
          commit('SET_SIDELINE',user.sideline)
          
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
